﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace WpfGridBinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged 
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = this;            
        }

        private object[] products;
        public object[] Products
        {
            get
            {
                if (this.products == null)
                {
                    using (EntitiesModel context = new EntitiesModel())
                    {
                        this.products = context.TenMostExpensiveProducts();
                    }
                }

                return this.products;
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName) 
        { 
            if (PropertyChanged != null)             
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName)); 
        } 
    }
}
